import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JPanel;
import objectdraw.*;

/*
 * Example of a program that allows a user to stack and
 * un-stack logs of wood.
 *
 * Jim Teresco, CSC 252, The College of Saint Rose, Fall 2013
 * Based on similar example from Williams College CS 134.
 *
 * $Id: RecWoodPile.java 2230 2013-10-27 02:26:10Z terescoj $
 */

public class RecWoodPile extends WindowController implements ActionListener {

    // dimensions of wood to be stacked
    private static final int WOOD_WIDTH = 100;
    private static final int WOOD_HT = 10;

    // the stacking displacement
    private static final int STACKING_DISP = 12;

    // the stack of wood
    private Stack theStack;

    // buttons that allow a user to select a mode (stacking or unstacking)
    private JButton stackEm, unStackEm;

    // the x and y locations of the next item of wood to be stacked
    private int x = 100;
    private int y = 340;

    // an image of wood
    private Image wood;

    public void begin() {
        // create the user interface components

        Container contentPane = getContentPane();
        stackEm = new JButton("Stack 'em");
        unStackEm = new JButton("Unstack 'em");

        JPanel buttonPanel = new JPanel();
        buttonPanel.add(stackEm);
        buttonPanel.add(unStackEm);

        contentPane.add(buttonPanel, BorderLayout.SOUTH);

        // add listeners
        stackEm.addActionListener(this);
        unStackEm.addActionListener(this);

        // the stack is initially empty
        theStack = new Stack(null, null);

        wood = getImage("wood.gif");
        
        contentPane.validate();
    }

    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == stackEm) {
            // put a new piece of wood on the stack
            VisibleImage theWood = new VisibleImage(wood, x, y, canvas);
            theWood.setWidth(WOOD_WIDTH);
            theWood.setHeight(WOOD_HT);
            theStack = new Stack(theWood, theStack);
            y = y - STACKING_DISP;
        } else if (!theStack.isEmpty()) {
            VisibleImage theWood = theStack.removeMostRecent();
            theWood.removeFromCanvas();
            y = y + STACKING_DISP;
        }
    }
}
